# Motivation

* Type classes, or something alike in OCaml
* Easy way to combine functions generated by ppx-deriving
* `"%A"` of printf to print anything

# Requirements

## Auto-conversion to constraints

A way to auto-convert the type of derivings depending on other derivings from:

```
val show_list : ('a -> string) -> 'a list -> string
```

to

```
val show_list : Show 'a => 'a list -> string
```

## Handling of inductively inconstructable types

Haskell's `Show` can handle only limited number of tuples,
since tuples are not inductively definable using tuples with less elements.
Actually the `Show` instances of tuples are defined one by one.

In OCaml, the situation is worse since we have more inductively inconstructable
types like poymorphic variants and objects.

We need an easy way to produce instances of `Show` for these types.

## Embedding in the current OCaml type algebra

Building a modified OCaml compiler is easy but hard to be tried by
other users (unless you have a strong position in the OCaml community :-PPP).

Implementing things as a PPX is one easy way to distribute 
compiler modifications to global public.
